#!/bin/bash

# This script installs C++TesK Eclipse Plug-in.
# It requires Eclipse IDE to be installed.
# 

ECLIPSE_PATH="$1"
ECLIPSE_EXECUTABLE="$ECLIPSE_PATH/eclipse"

if [[ -f "$ECLIPSE_EXECUTABLE" && -x "$ECLIPSE_EXECUTABLE" ]]; then

  PLUGIN_NAME_PREFIX="com.unitesk.cpptesk.ide_"

  PWD=`pwd`

  rm -rf "$PWD/plugins/plugins"
  rm -rf "$PWD/plugins/features"
  rm -rf "$PWD/plugins/site.xml"

  unzip "$PWD/plugins/CPPTESK_Eclipse_plugin.zip" -d "$PWD/plugins"

  if [[ -n `find -L "$ECLIPSE_PATH/plugins/" -maxdepth 1 -name "$PLUGIN_NAME_PREFIX"'*.jar' -type f -print 2>/dev/null` ]]; then
    $ECLIPSE_PATH/eclipse -nosplash -application org.eclipse.equinox.p2.director -repository file://$PWD/plugins/ -uninstallIU   com.unitesk.cpptesk.ide.feature.feature.group
  fi

  $ECLIPSE_PATH/eclipse -nosplash -application org.eclipse.equinox.p2.director -repository file://$PWD/plugins/ -installIU   com.unitesk.cpptesk.ide.feature.feature.group

else
  echo "ERROR: incorrect path to Eclipse instance - \"eclipse\" binary not found."
  exit -1
fi

exit 0
