#pragma once
#include <c_tracer/c_tracer.h>
#include <ts/generated.h>
#include <atl/object.hpp>
#include <ts/scenario/context.hpp>

namespace cpptesk
{
namespace ts
{

//
//     
//

template <typename T, T gs() >
Object * get_state()
{
    return cpptesk::atl::CppObject<T>::create(gs());
}

//   dfsm.  .
template <typename T, bool sf(T&) >
Object * init_iterator()
{
    cpptesk::atl::CppObject<T>* result = cpptesk::atl::CppObject<T>::create();
    result->ptr()->__mode = INIT_ITERATION;
    if (sf(result->ref()))
    {
        return  result;
    }
    else
    {
        ::destroy_Object(result);
        return 0;
    }
}

//   dfsm.    invoke
template <typename T,  bool sf(T&)>
bool has_next_value_iterator(Object * arg)
{
    if (!arg) return false;
    cpptesk::atl::CppObject<T> * obj = (cpptesk::atl::CppObject<T>*)arg;
    assert(obj->ptr());
//    obj->ptr()->__mode = NEXT_ITERATION;
//    bool result = sf(obj->ref());
    bool result = !(obj->ref().__done);
    ::destroy_Object(arg);
    return result;
}

//   dfsm.    .     .

//  
template <typename T,  bool sf(T&)>
bool next_value_helper(T& ctx)
{
    ctx.__mode = NEXT_ITERATION;
    bool result = sf(ctx);
    return result;
}

template <typename T,  bool sf(T&)>
bool next_value_iterator(Object * arg)
{
    if (!arg) return false;
    cpptesk::atl::CppObject<T> * obj = (cpptesk::atl::CppObject<T>*)arg;
    assert(obj->ptr());
    bool result = next_value_helper(obj->ref());
    ::destroy_Object(arg);
    return result;
}

//   dfsm.   

//  
template <typename T,  bool sf(T&)>
bool invoke_helper(T& ctx, const char * name)
{
    if (next_value_helper(ctx))
    {
        ::clearOracleVerdict();
        std::ostringstream out;
        out << ctx;
        ::traceScenarioValue(
            "iteration variable",
            name,
            "iterator",
            out.str().c_str()
        );
        ctx.__mode = INVOKE_ACTION;
        bool result = sf(ctx);
        return result;
    }
    else
    {
        return true;
    }
}

template <typename T,  bool sf(T&)>
bool invoke_iterator(Object * arg)
{
    if (!arg) return true;
    cpptesk::atl::CppObject<T> * obj = (cpptesk::atl::CppObject<T>*)arg;
    assert(obj->ptr());
    bool result = invoke_helper(obj->ref(), TYPE(obj));
    ::destroy_Object(arg);
    return result;
}

} // namespace cpptesk::ts
} // namespace cpptesk
