/** @file fifo_msg.cpp
 * This file contains the reference model message classes implementation.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#include <fifo_msg.h>

namespace cpptesk {
namespace examples {
namespace fifo {

InputData::InputData(void)
{
    // Add data field
    ADD_FIELD(InputData::data);
    // Randomization of all the added fields
    RANDOMIZE_MESSAGE(*this);
}

InputData::~InputData(void) {}

OutputData::OutputData(void)
{
    // Add data field
    ADD_FIELD(OutputData::data);
}

OutputData::OutputData(uint8_t output_data)
{
    // Add data field
    ADD_FIELD(OutputData::data);
    // Set data field according to the output_data parameter
    data = output_data;
}

OutputData::~OutputData(void) {}

}}}

