/** @file fifo_media.h
 *       FIFO.
 *
 * @author   (chupilko@ispras.ru)
 */

#pragma once

#include <hw/veritool/media.hpp>
#include <fifo_model.h>
#include <interface.h>

#include <string>

namespace cpptesk {
namespace examples {
namespace fifo {

/**
 * @brief    FIFO.
 */
CPPTESK_VERITOOL_MEDIA(FIFOMediator, FIFO)
{
public:
    FIFOMediator();
    virtual ~FIFOMediator();

    ///      ( ).
    const static int REACTION_TIMEOUT = 100;

    virtual bool isIface1Ready() const;
    virtual bool isIface2Ready() const;

    ///    iface1.
    CPPTESK_DECLARE_PROCESS(serialize_iface1);
    ///    iface2.
    CPPTESK_DECLARE_PROCESS(serialize_iface2);

    ///    iface3.
    CPPTESK_DECLARE_PROCESS(deserialize_iface3);

    ///      iface3.
    CPPTESK_DEFINE_BASIC_OUTPUT_LISTENER(listen_iface3, iface3, outputs.DO_VAL);

    ///         .
    CPPTESK_DECLARE_ARBITER(CPPTESK_PRIORITY_ARBITER, matcher_iface3);
};

}}}

