/** @file fifo_scen.h
 *      FIFO.
 *
 * @author   (chupilko@ispras.ru)
 */

#pragma once

#include <fifo_media.h>

#include <ts/scenario.hpp>

using namespace cpptesk::ts;
using namespace cpptesk::hw;
using namespace cpptesk::tracer;

namespace cpptesk {
namespace examples {
namespace fifo {

///      .
CPPTESK_SCENARIO(FIFOScenario)
{
public:
    //   
    typedef IntAbcCtx Ctx;

    ///  .
    virtual bool init(int argc, char ** argv);
    ///   .
    virtual void finish();

    ///   NOP -        .
    bool scen_nop(Ctx& ctx);
    ///   "   ".
    bool scen_push(Ctx& ctx);
    ///   "   ".
    bool scen_pop(Ctx& ctx);

    ///    . @return     .
    std::string get_state_fifo();

    FIFOScenario(void);
    virtual ~FIFOScenario(void);

protected:
    ///     .
    FIFOMediator dut;
};

/// -   .
class ExampleScenario : public FIFOScenario
{
public:
    ExampleScenario();
    virtual ~ExampleScenario();
};

}}}

