/*
 * Generated by veritool: Copyright (c) 2009-2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 */

`timescale 1 ns/1 ps

module testbench();

    parameter HALF_CYCLE_DELAY = 5;
    parameter RESET_CYCLE_NUMBER = 3;
    parameter INC_CYCLE_ACCORD_TO_FRONT_OF_CLK = 1;

    reg CE_RD;
    reg CE_RD_reg;
    reg CE_WR;
    reg CE_WR_reg;
    reg CLK;
    reg [7:0] DI;
    reg [7:0] DI_reg;
    reg RST;
    reg run;
    wire [7:0] DO;
    wire DO_VAL;
    wire IS_EMPTY;
    wire IS_FULL;

    always @(posedge CLK) begin
        CE_RD_reg <= CE_RD;
        CE_WR_reg <= CE_WR;
        DI_reg <= DI;
    end

    myfifo target (
        .CE_RD(CE_RD_reg),
        .CE_WR(CE_WR_reg),
        .CLK(CLK),
        .DI(DI_reg),
        .RST(RST),
        .DO(DO),
        .DO_VAL(DO_VAL),
        .IS_EMPTY(IS_EMPTY),
        .IS_FULL(IS_FULL)
    );

    reg [63 : 0] CYCLE;
    reg [256 * 8 : 1] argv;
    reg [64 * 8 : 1] pstring;
    reg netscen;

    task cycle;
    input inc_CYCLE;
    begin
        CLK = 0; #(HALF_CYCLE_DELAY);
        if(inc_CYCLE == 1 && INC_CYCLE_ACCORD_TO_FRONT_OF_CLK == 1) CYCLE = CYCLE + 1;
        CLK = 1; #(HALF_CYCLE_DELAY);
        if(inc_CYCLE == 1 && INC_CYCLE_ACCORD_TO_FRONT_OF_CLK == 0) CYCLE = CYCLE + 1;
    end
    endtask

    task delay;
    input inc_CYCLE;
    input [31:0] number_of_cycles;
    reg [31:0] i;
    begin
        i = 0;
        while(i < number_of_cycles)
        begin
            cycle(inc_CYCLE);
            i = i + 1;
        end
    end
    endtask

    initial begin
        $dumpfile("testbench.vcd");
        $dumpvars(1, testbench);
        CE_RD = 1'h0;
        CE_WR = 1'h0;
        CLK = 1'h0;
        DI = 8'h00;
        RST = 1'h0;
        CYCLE = 0;
        RST = 1'h1;
        delay(0, RESET_CYCLE_NUMBER);

        RST = 1'h0;

        if($test$plusargs("netscen"))
            netscen = 1;
        else
            netscen = 0;

        argv = 0;
        if($value$plusargs("argv=%s", argv)) begin
        end

        if($value$plusargs("scen=%s", pstring)) begin
            $setScenario(netscen, argv, pstring);
            run = 1'h1;
        end
        else begin
            $display("Please, type a scenario name with +scen=SCEN_NAME parameter");
            run = 1'h0;
        end

        while(run) begin
            $applyAction();
            cycle(1);
            $checkAction();
        end
        cycle(1);
    end
endmodule

