/** @file fifo_msg.cpp
 * Messages classes used inside test systems.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#include <fifo_msg.h>

namespace cpptesk {
namespace examples {
namespace fifo {

InputData::InputData(void)
{
    // add "data" field.
    CPPTESK_ADD_FIELD(InputData::data);
    // randomization all the added fields.
    randomize();
}

InputData::~InputData(void) {}

OutputData::OutputData(void)
{
    // add "data" field.
    CPPTESK_ADD_FIELD(OutputData::data);
}

OutputData::OutputData(uint64_t output_data)
{
    // add "data" field.
    CPPTESK_ADD_FIELD(OutputData::data);
    // setting data field value according to input value.
    data = output_data;
}

OutputData::~OutputData(void) {}

}}}

