/*
 * Copyright 2010-2013 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: Rule # 2 in C++TESK.ErrorDiagnostics.ru.doc: {[o,o] -> [x,x]}  
//           Use for normal reactions
///////////////////////////////////////////////////////////////////////////////

#include <hw/diagnostics/rules/rule1.hpp>

namespace cpptesk {
namespace hw {
namespace diagnostics {

void Rule1::assign_rule_number(ReactionUnit &ru1, ReactionUnit &ru2,
                               int rule, CollapseType type)
{
    ru1.set_collapse_rule(rule);
    ru1.set_collapse_type(type);

    CPPTESK_UNUSED_ARG(ru2);
};

ReactionUnitVector Rule1::apply(ReactionUnit &ru1, ReactionUnit &ru2) //TODO
{
    ReactionUnitVector result;

    ru1.set_collapsed();
    CPPTESK_UNUSED_ARG(ru2);

    return result;
}

int Rule1::check(cpptesk::hw::Reaction &r1, cpptesk::hw::Reaction &r2)
{
    CPPTESK_UNUSED_ARG(r2);

    return r1.getError() == NORMAL_REACTION ? EXACT_MATCH : FALSE_MATCH;
}

std::string Rule1::toString()
{
    return "for NORMAL reaction: {[a:a] => [x:x]}";
}

}}}
