/*
 * Copyright 2010-2013 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: 
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <stdint.h>

namespace cpptesk {
namespace hw {

struct SimulationInfo {
    /// Number of stimulus
    unsigned stimuli;
    
    /// Number of all reactions
    unsigned reactions;
    
    /// Number of normal reactions
    unsigned reaction_normal;
    
    /// Number of incorrect reactions
    unsigned reaction_incorrect;
    
    /// Number of missing reactions
    unsigned reaction_missing;
    unsigned optional_missing;
    unsigned expected_missing;

    /// Number of unexpected reactions
    unsigned reaction_unexpected;
    
    /// Cycles of test
    uint64_t cycles; 
    
    /// Test simulation time
    time_t time; 
    
    /// Missing Reaction Timeout
    cycle_t reaction_timeout;

    /// Unexpected Reaction Timeout
    cycle_t unexpected_reaction_timeout;
};

}}
