/*
 * Copyright 2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* 
 * File: aspect_fsm.h
 * Description: 
 *       This file contains interface definition of Aspectrace aspect "fsm".
 */

#ifndef __ASPECT_FSM_H
#define __ASPECT_FSM_H

#include <atl/map.h>
#include "aspectrace.h"

void aspect_fsm_traceFsmStart( const char *scenarioName );
void aspect_fsm_traceState( const char *stateId, const char *stateText /* may be NULL */ );
void aspect_fsm_traceTransitionStart( const char *id, const char *scenFuncName );
void aspect_fsm_traceIterationVariable( const char *type, const char *name, Object *value );
void aspect_fsm_traceTransitionEnd( const char *id, const char *scenFuncName );
void aspect_fsm_traceSummary( Map *sumary );
void aspect_fsm_traceBrowserMessage( enum MessageLevel level, const char *message );
void aspect_fsm_traceFsmEnd( );


#endif /* __ASPECT_FSM_H */
