/*
 * Copyright 2014 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __NETFSM2_H_INCLUDED__
#define __NETFSM2_H_INCLUDED__

#include <netfsm/generator.h>

////////////////////////////////////////////////////////////////////////////////
// -------------------------------------------------------------------------- //
// | Common command line parameters:                                        | //
// -------------------------------------------------------------------------- //
//                                                                            //
// --cpu <non_negative_number>    - CPU (or cluster node) identifier used (1) //
//                                  to  initialize the random generator and   //
//                                  (2) to choose an arc (transition) to be   //
//                                  applied (if --randomize is not set).      //
//                                                                            //
// --length <non_negative_number> - test sequence length, i.e. number of test //
//                                  actions to be applied to a target system. //
//                                  If this parameter is not set, testing is  //
//                                  finished when all reachable nodes (states)// 
//                                  and arcs (transitions) are traversed.     //
//                                                                            //
// -------------------------------------------------------------------------- //
// | Specific command line parameters:                                      | //
// -------------------------------------------------------------------------- //
//                                                                            //
// --number <greater_than_2>      - the number of component FSMs.             //
//                                                                            //
// --delimiter <character>        - the state delimiter.                      //
//                                                                            //
// --engine <name>                - the base FSM engine (fsm or pfsm).        //
//                                                                            //
// -------------------------------------------------------------------------- //
// | Default values of the command line parameters:                         | //
// -------------------------------------------------------------------------- //
//                                                                            //
// --fsm-number 2                                                             //
//                                                                            //
// --delimiter  ;                                                             //
//                                                                            //
// --engine fsm                                                               //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

extern TestEngine TE_FSM2;

#define ENGINE_FSM2 (&TE_FSM2)

#endif
