/*
 * Copyright 2014 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __NETPFSM_H_INCLUDED__
#define __NETPFSM_H_INCLUDED__

#include <netfsm/generator.h>

////////////////////////////////////////////////////////////////////////////////
// -------------------------------------------------------------------------- //
// | Common command line parameters:                                        | //
// -------------------------------------------------------------------------- //
//                                                                            //
// --cpu <non_negative_number>    - CPU (or cluster node) identifier used to  //
//                                  initialize the random number generator.   //
//                                                                            //
// --length <non_negative_number> - test sequence length, i.e. number of test //
//                                  actions to be applied to a target system. //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

extern TestEngine TE_PFSM;

#define ENGINE_PFSM (&TE_PFSM)

#endif
